Index: springapp/src/main/java/mk/profesori/springapp/Model/Post.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Model/Post.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Model/Post.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -3,4 +3,5 @@
 import com.fasterxml.jackson.annotation.JsonIdentityInfo;
 import com.voodoodyne.jackson.jsog.JSOGGenerator;
+import lombok.Data;
 import lombok.NoArgsConstructor;
 
@@ -13,4 +14,5 @@
 
 @Entity(name = "post")
+@Data
 @Inheritance(strategy = InheritanceType.SINGLE_TABLE)
 @DiscriminatorColumn(name = "post_type", discriminatorType = DiscriminatorType.STRING)
@@ -44,9 +46,10 @@
     private Post parent;
 
-    @OneToMany(mappedBy = "post", cascade = CascadeType.ALL, orphanRemoval = true)
+    @OneToMany(mappedBy = "post", cascade = CascadeType.ALL, orphanRemoval = true, fetch = FetchType.EAGER)
     private Set<PostVote> votes = new HashSet<>();
 
-    @OneToMany(mappedBy = "post", cascade={CascadeType.PERSIST})
+    @OneToMany(mappedBy = "post", cascade={CascadeType.PERSIST}, fetch = FetchType.EAGER)
     private Set<PostReport> reports = new HashSet<>();
+
     @PreRemove
     public void preRemove() {
@@ -56,80 +59,6 @@
         });
     }
-
-
-    @OneToMany(mappedBy = "parent", cascade = CascadeType.ALL, orphanRemoval = true)
+    @OneToMany(mappedBy = "parent", orphanRemoval = true, fetch = FetchType.EAGER)
     private List<Post> children = new ArrayList<>();
-
-    // getters and setters
-    public Set<PostVote> getVotes() {
-        return votes;
-    }
-
-    public void setVotes(Set<PostVote> votes) {
-        this.votes = votes;
-    }
-    public Long getPostId() {
-        return postId;
-    }
-
-    public void setPostId(Long postId) {
-        this.postId = postId;
-    }
-
-    public String getTitle() {
-        return title;
-    }
-
-    public void setTitle(String title) {
-        this.title = title;
-    }
-
-    public String getContent() {
-        return content;
-    }
-
-    public void setContent(String content) {
-        this.content = content;
-    }
-
-    public CustomUserDetails getAuthor() {
-        return author;
-    }
-
-    public void setAuthor(CustomUserDetails author) {
-        this.author = author;
-    }
-
-    public LocalDateTime getTimePosted() {
-        return timePosted;
-    }
-
-    public void setTimePosted(LocalDateTime timePosted) {
-        this.timePosted = timePosted;
-    }
-
-    public LocalDateTime getTimeLastEdited() {
-        return timeLastEdited;
-    }
-
-    public void setTimeLastEdited(LocalDateTime timeLastEdited) {
-        this.timeLastEdited = timeLastEdited;
-    }
-
-    public Post getParent() {
-        return parent;
-    }
-
-    public void setParent(Post parent) {
-        this.parent = parent;
-    }
-
-    public List<Post> getChildren() {
-        return children;
-    }
-
-    public void setChildren(List<Post> children) {
-        this.children = children;
-    }
 
     // konstruktor so parent (koga e reply)
Index: springapp/src/main/java/mk/profesori/springapp/Model/PostReport.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Model/PostReport.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Model/PostReport.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,4 +1,5 @@
 package mk.profesori.springapp.Model;
 
+import lombok.Data;
 import lombok.NoArgsConstructor;
 
@@ -7,4 +8,5 @@
 
 @Entity
+@Data
 @NoArgsConstructor
 public class PostReport {
@@ -38,51 +40,3 @@
         this.resolved=false;
     }
-
-    public boolean isResolved() {
-        return resolved;
-    }
-
-    public void setResolved(boolean resolved) {
-        this.resolved = resolved;
-    }
-
-    public Long getPostReportId() {
-        return postReportId;
-    }
-
-    public void setPostReportId(Long postReportId) {
-        this.postReportId = postReportId;
-    }
-
-    public CustomUserDetails getUser() {
-        return user;
-    }
-
-    public void setUser(CustomUserDetails user) {
-        this.user = user;
-    }
-
-    public Post getPost() {
-        return post;
-    }
-
-    public void setPost(Post post) {
-        this.post = post;
-    }
-
-    public LocalDateTime getTime() {
-        return time;
-    }
-
-    public void setTime(LocalDateTime time) {
-        this.time = time;
-    }
-
-    public String getDescription() {
-        return description;
-    }
-
-    public void setDescription(String description) {
-        this.description = description;
-    }
 }
Index: springapp/src/main/java/mk/profesori/springapp/Model/PostVote.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Model/PostVote.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Model/PostVote.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,4 +1,5 @@
 package mk.profesori.springapp.Model;
 
+import lombok.Data;
 import lombok.NoArgsConstructor;
 
@@ -7,4 +8,5 @@
 
 @Entity
+@Data
 @NoArgsConstructor
 public class PostVote {
@@ -34,43 +36,3 @@
         this.vote = vote;
     }
-
-    public Long getPostVoteId() {
-        return postVoteId;
-    }
-
-    public void setPostVoteId(Long id) {
-        this.postVoteId = id;
-    }
-
-    public CustomUserDetails getUser() {
-        return user;
-    }
-
-    public void setUser(CustomUserDetails user) {
-        this.user = user;
-    }
-
-    public Post getPost() {
-        return post;
-    }
-
-    public void setPost(Post post) {
-        this.post = post;
-    }
-
-    public LocalDateTime getTime() {
-        return time;
-    }
-
-    public void setTime(LocalDateTime time) {
-        this.time = time;
-    }
-
-    public VoteType getVote() {
-        return vote;
-    }
-
-    public void setVote(VoteType vote) {
-        this.vote = vote;
-    }
 }
Index: springapp/src/main/java/mk/profesori/springapp/Model/Professor.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Model/Professor.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Model/Professor.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,21 +1,14 @@
 package mk.profesori.springapp.Model;
-
-import java.util.ArrayList;
-import java.util.List;
-import javax.persistence.CascadeType;
-import javax.persistence.Column;
-import javax.persistence.Entity;
-import javax.persistence.GeneratedValue;
-import javax.persistence.GenerationType;
-import javax.persistence.Id;
-import javax.persistence.JoinColumn;
-import javax.persistence.ManyToOne;
-import javax.persistence.OneToMany;
-import javax.persistence.Table;
 
 import com.fasterxml.jackson.annotation.JsonIdentityInfo;
 import com.voodoodyne.jackson.jsog.JSOGGenerator;
+import lombok.Data;
+
+import javax.persistence.*;
+import java.util.ArrayList;
+import java.util.List;
 
 @Entity
+@Data
 @Table(name = "professor")
 @JsonIdentityInfo(generator = JSOGGenerator.class)
@@ -34,22 +27,6 @@
     private Faculty faculty;
 
+    @Transient
     @OneToMany(mappedBy = "targetProfessor", cascade = CascadeType.ALL)
-    private List<Opinion> relatedOpinions = new ArrayList<Opinion>();
-
-    // getters
-    public Long getProfessorId() {
-        return professorId;
-    }
-
-    public String getProfessorName() {
-        return professorName;
-    }
-
-    public Faculty getFaculty() {
-        return faculty;
-    }
-
-    public List<Opinion> getRelatedOpinions() {
-        return relatedOpinions;
-    }
+    private List<Opinion> relatedOpinions = new ArrayList<>();
 }
Index: springapp/src/main/java/mk/profesori/springapp/Model/StudyProgramme.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Model/StudyProgramme.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Model/StudyProgramme.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,21 +1,14 @@
 package mk.profesori.springapp.Model;
 
+import com.fasterxml.jackson.annotation.JsonIdentityInfo;
+import com.voodoodyne.jackson.jsog.JSOGGenerator;
+import lombok.Data;
+
+import javax.persistence.*;
 import java.util.HashSet;
 import java.util.Set;
 
-import javax.persistence.Column;
-import javax.persistence.Entity;
-import javax.persistence.GeneratedValue;
-import javax.persistence.GenerationType;
-import javax.persistence.Id;
-import javax.persistence.JoinColumn;
-import javax.persistence.ManyToOne;
-import javax.persistence.OneToMany;
-import javax.persistence.Table;
-
-import com.fasterxml.jackson.annotation.JsonIdentityInfo;
-import com.voodoodyne.jackson.jsog.JSOGGenerator;
-
 @Entity
+@Data
 @Table(name = "study_programme")
 @JsonIdentityInfo(generator = JSOGGenerator.class)
@@ -37,27 +30,7 @@
     private Faculty faculty;
 
+    @Transient
     @OneToMany(mappedBy = "studyProgramme")
     private Set<Subject> subjects = new HashSet<>();
 
-    // getters
-    public Long getStudyProgrammeId() {
-        return studyProgrammeId;
-    }
-
-    public String getStudyProgrammeName() {
-        return studyProgrammeName;
-    }
-
-    public int getCycle() {
-        return cycle;
-    }
-
-    public Faculty getFaculty() {
-        return faculty;
-    }
-
-    public Set<Subject> getSubjects() {
-        return subjects;
-    }
-
 }
Index: springapp/src/main/java/mk/profesori/springapp/Model/Subject.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Model/Subject.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Model/Subject.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,21 +1,14 @@
 package mk.profesori.springapp.Model;
-
-import java.util.ArrayList;
-import java.util.List;
-import javax.persistence.CascadeType;
-import javax.persistence.Column;
-import javax.persistence.Entity;
-import javax.persistence.GeneratedValue;
-import javax.persistence.GenerationType;
-import javax.persistence.Id;
-import javax.persistence.JoinColumn;
-import javax.persistence.ManyToOne;
-import javax.persistence.OneToMany;
-import javax.persistence.Table;
 
 import com.fasterxml.jackson.annotation.JsonIdentityInfo;
 import com.voodoodyne.jackson.jsog.JSOGGenerator;
+import lombok.Data;
+
+import javax.persistence.*;
+import java.util.ArrayList;
+import java.util.List;
 
 @Entity
+@Data
 @Table(name = "subject")
 @JsonIdentityInfo(generator = JSOGGenerator.class)
@@ -34,23 +27,7 @@
     private StudyProgramme studyProgramme;
 
+    @Transient
     @OneToMany(mappedBy = "targetSubject", cascade = CascadeType.ALL)
     private List<_Thread> threads = new ArrayList<>();
 
-    // getters
-    public Long getSubjectId() {
-        return subjectId;
-    }
-
-    public String getSubjectName() {
-        return subjectName;
-    }
-
-    public StudyProgramme getStudyProgramme() {
-        return studyProgramme;
-    }
-
-    public List<_Thread> getThreads() {
-        return threads;
-    }
-
 }
Index: springapp/src/main/java/mk/profesori/springapp/Model/University.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Model/University.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Model/University.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,21 +1,14 @@
 package mk.profesori.springapp.Model;
 
+import com.fasterxml.jackson.annotation.JsonIdentityInfo;
+import com.voodoodyne.jackson.jsog.JSOGGenerator;
+import lombok.Data;
+
+import javax.persistence.*;
 import java.util.HashSet;
 import java.util.Set;
 
-import javax.persistence.Column;
-import javax.persistence.Entity;
-import javax.persistence.GeneratedValue;
-import javax.persistence.GenerationType;
-import javax.persistence.Id;
-import javax.persistence.JoinColumn;
-import javax.persistence.ManyToOne;
-import javax.persistence.OneToMany;
-import javax.persistence.Table;
-
-import com.fasterxml.jackson.annotation.JsonIdentityInfo;
-import com.voodoodyne.jackson.jsog.JSOGGenerator;
-
 @Entity
+@Data
 @Table(name = "university")
 @JsonIdentityInfo(generator = JSOGGenerator.class)
@@ -34,23 +27,6 @@
     private City city;
 
+    @Transient
     @OneToMany(mappedBy = "university")
     private Set<Faculty> faculties = new HashSet<>();
-
-    // getters
-    public Long getUniversityId() {
-        return universityId;
-    }
-
-    public String getUniversityName() {
-        return universityName;
-    }
-
-    public City getCity() {
-        return city;
-    }
-
-    public Set<Faculty> getFaculties() {
-        return faculties;
-    }
-
 }
Index: springapp/src/main/java/mk/profesori/springapp/Model/_Thread.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Model/_Thread.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Model/_Thread.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,17 +1,16 @@
 package mk.profesori.springapp.Model;
 
-import java.time.LocalDateTime;
-
-import java.util.List;
+import lombok.Data;
+import lombok.NoArgsConstructor;
 
 import javax.persistence.DiscriminatorValue;
-
 import javax.persistence.Entity;
 import javax.persistence.JoinColumn;
 import javax.persistence.ManyToOne;
-
-import lombok.NoArgsConstructor;
+import java.time.LocalDateTime;
+import java.util.List;
 
 @Entity
+@Data
 @DiscriminatorValue("thread")
 @NoArgsConstructor
@@ -36,11 +35,3 @@
         this.targetSubject = targetSubject;
     }
-
-    public Subject getTargetSubject() {
-        return targetSubject;
-    }
-
-    public void setTargetSubject(Subject targetSubject) {
-        this.targetSubject = targetSubject;
-    }
 }
Index: springapp/src/main/java/mk/profesori/springapp/Repository/FacultyRepository.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Repository/FacultyRepository.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Repository/FacultyRepository.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,17 +1,23 @@
 package mk.profesori.springapp.Repository;
+
+import mk.profesori.springapp.Model.Faculty;
+import mk.profesori.springapp.Model.University;
+import org.springframework.data.jpa.repository.Query;
+import org.springframework.data.repository.CrudRepository;
+import org.springframework.data.repository.query.Param;
+import org.springframework.stereotype.Repository;
 
 import java.util.List;
 
-import org.springframework.data.repository.CrudRepository;
-import org.springframework.stereotype.Repository;
-
-import mk.profesori.springapp.Model.Faculty;
-import mk.profesori.springapp.Model.University;
-
 @Repository
 public interface FacultyRepository extends CrudRepository<Faculty, Long>{
-
     List<Faculty> findAll();
     Faculty findByFacultyId(Long id);
     List<Faculty> findByUniversity(University university);
+    @Query(value = "select professor.id, count(p.*)\n" +
+            "from professor left join post p on professor.id = p.professor_id\n" +
+            "where professor.faculty_id = :facultyId\n" +
+            "group by professor.id\n" +
+            "order by professor.id;", nativeQuery = true)
+    List<String> getOpinionCountForEachProfessorInFaculty(@Param("facultyId") Long id);
 }
Index: springapp/src/main/java/mk/profesori/springapp/Repository/OpinionRepository.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Repository/OpinionRepository.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Repository/OpinionRepository.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -2,9 +2,14 @@
 
 import mk.profesori.springapp.Model.Opinion;
+import mk.profesori.springapp.Model.Professor;
 import org.springframework.data.repository.CrudRepository;
 import org.springframework.stereotype.Repository;
+
+import java.util.List;
 
 @Repository
 public interface OpinionRepository extends CrudRepository<Opinion,Long> {
     Opinion findByPostId(Long postId);
+    List<Opinion> findByTargetProfessor(Professor p);
+    List<Opinion> findTop10ByOrderByTimePosted();
 }
Index: springapp/src/main/java/mk/profesori/springapp/Repository/PostRepository.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Repository/PostRepository.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
+++ springapp/src/main/java/mk/profesori/springapp/Repository/PostRepository.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -0,0 +1,13 @@
+package mk.profesori.springapp.Repository;
+
+import mk.profesori.springapp.Model.CustomUserDetails;
+import mk.profesori.springapp.Model.Post;
+import org.springframework.data.repository.CrudRepository;
+import org.springframework.stereotype.Repository;
+
+import java.util.Set;
+
+@Repository
+public interface PostRepository extends CrudRepository<Post, Long> {
+    Set<Post> findByAuthor(CustomUserDetails c);
+}
Index: springapp/src/main/java/mk/profesori/springapp/Repository/PostVoteRepository.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Repository/PostVoteRepository.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Repository/PostVoteRepository.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,10 +1,14 @@
 package mk.profesori.springapp.Repository;
 
+import mk.profesori.springapp.Model.Post;
 import mk.profesori.springapp.Model.PostVote;
 import org.springframework.data.repository.CrudRepository;
 import org.springframework.stereotype.Repository;
 
+import java.util.List;
+
 @Repository
 public interface PostVoteRepository extends CrudRepository<PostVote,Long> {
     PostVote findByPostVoteId(Long id);
+    List<PostVote> findByPost(Post post);
 }
Index: springapp/src/main/java/mk/profesori/springapp/Repository/StudyProgrammeRepository.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Repository/StudyProgrammeRepository.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Repository/StudyProgrammeRepository.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,18 +1,24 @@
 package mk.profesori.springapp.Repository;
-
-import java.util.List;
-
-import org.springframework.data.repository.CrudRepository;
-import org.springframework.stereotype.Repository;
 
 import mk.profesori.springapp.Model.Faculty;
 import mk.profesori.springapp.Model.StudyProgramme;
+import org.springframework.data.jpa.repository.Query;
+import org.springframework.data.repository.CrudRepository;
+import org.springframework.data.repository.query.Param;
+import org.springframework.stereotype.Repository;
+
+import java.util.List;
 
 
 @Repository
 public interface StudyProgrammeRepository extends CrudRepository<StudyProgramme, Long>{
-    
     List<StudyProgramme> findAll();
     StudyProgramme findByStudyProgrammeId(Long id);
     List<StudyProgramme> findByFaculty(Faculty faculty);
+    @Query(value = "select subject.id, count(p.*)\n" +
+            "from subject left join post p on subject.id = p.subject_id\n" +
+            "where subject.study_programme_id = :studyProgrammeId\n" +
+            "group by subject.id\n" +
+            "order by subject.id;", nativeQuery = true)
+    List<String> getThreadCountForEachSubjectInStudyProgramme(@Param("studyProgrammeId") Long id);
 }
Index: springapp/src/main/java/mk/profesori/springapp/Repository/SubjectRepository.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Repository/SubjectRepository.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Repository/SubjectRepository.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,11 +1,15 @@
 package mk.profesori.springapp.Repository;
 
+import mk.profesori.springapp.Model.StudyProgramme;
+import mk.profesori.springapp.Model.Subject;
 import org.springframework.data.repository.CrudRepository;
 import org.springframework.stereotype.Repository;
 
-import mk.profesori.springapp.Model.Subject;
+import java.util.List;
 
 @Repository
 public interface SubjectRepository extends CrudRepository<Subject, Long> {
     Subject findBySubjectId(Long id);
+    List<Subject> findByStudyProgramme(StudyProgramme studyProgramme);
+    List<Subject> findBySubjectNameContainingIgnoreCase(String name);
 }
Index: springapp/src/main/java/mk/profesori/springapp/Repository/UniversityRepository.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Repository/UniversityRepository.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Repository/UniversityRepository.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,19 +1,39 @@
 package mk.profesori.springapp.Repository;
+
+import mk.profesori.springapp.Model.City;
+import mk.profesori.springapp.Model.University;
+import org.springframework.data.jpa.repository.Query;
+import org.springframework.data.repository.CrudRepository;
+import org.springframework.stereotype.Repository;
 
 import java.util.List;
 
-import org.springframework.data.repository.CrudRepository;
-import org.springframework.stereotype.Repository;
-
-import mk.profesori.springapp.Model.City;
-import mk.profesori.springapp.Model.University;
-
 @Repository
 public interface UniversityRepository extends CrudRepository<University, Long> {
-
     List<University> findAll();
 
     University findByUniversityId(Long id);
-
     List<University> findByCity(City city);
+    
+    @Query(value = "select facultyid, sectioncount, opinioncount from\n" +
+            "(select faculty_id as facultyid, t1.subject_count+t2.professor_count as sectioncount\n" +
+            "from (select sp.faculty_id, count(*) as subject_count\n" +
+            "      from subject s join study_programme sp on s.study_programme_id = sp.id\n" +
+            "      group by sp.faculty_id) as t1\n" +
+            "         natural join\n" +
+            "     (select count(*) as professor_count, f.id as faculty_id\n" +
+            "      from professor p join faculty f on f.id = p.faculty_id\n" +
+            "      group by f.id) as t2) as q1\n" +
+            "natural join\n" +
+            "(select facultyid, count1+count2 as opinioncount from\n" +
+            "    (select pr.faculty_id as facultyid, count(*) as count1\n" +
+            "    from post po join professor pr on po.professor_id = pr.id\n" +
+            "    where professor_id is not null\n" +
+            "    group by pr.faculty_id) as t3\n" +
+            "    natural join\n" +
+            "    (select sp.faculty_id as facultyid, count(*) as count2\n" +
+            "    from post po join subject s on po.subject_id = s.id join study_programme sp on s.study_programme_id = sp.id\n" +
+            "    where po.subject_id is not null\n" +
+            "    group by sp.faculty_id) as t4) as q2;", nativeQuery = true)
+    List<String> findSectionAndPostCount();
 }
Index: springapp/src/main/java/mk/profesori/springapp/Repository/UserRepository.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Repository/UserRepository.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Repository/UserRepository.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,6 +1,5 @@
 package mk.profesori.springapp.Repository;
 
-import java.util.Optional;
-
+import mk.profesori.springapp.Model.CustomUserDetails;
 import org.springframework.data.jpa.repository.JpaRepository;
 import org.springframework.data.jpa.repository.Modifying;
@@ -9,5 +8,5 @@
 import org.springframework.transaction.annotation.Transactional;
 
-import mk.profesori.springapp.Model.CustomUserDetails;
+import java.util.Optional;
 
 @Repository
@@ -16,4 +15,5 @@
     Optional<CustomUserDetails> findByEmail(String email);
     Optional<CustomUserDetails> findByUsername(String username);
+    Optional<CustomUserDetails> findById(Long id);
 
     @Transactional
Index: springapp/src/main/java/mk/profesori/springapp/Repository/_ThreadRepository.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Repository/_ThreadRepository.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Repository/_ThreadRepository.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -1,10 +1,15 @@
 package mk.profesori.springapp.Repository;
 
+import mk.profesori.springapp.Model.Subject;
 import mk.profesori.springapp.Model._Thread;
 import org.springframework.data.repository.CrudRepository;
 import org.springframework.stereotype.Repository;
 
+import java.util.List;
+
 @Repository
 public interface _ThreadRepository extends CrudRepository<_Thread,Long> {
     _Thread findByPostId(Long postId);
+    List<_Thread> findTop10ByOrderByTimePosted();
+    List<_Thread> findByTargetSubject(Subject s);
 }
Index: springapp/src/main/java/mk/profesori/springapp/Security/SecurityConfiguration.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Security/SecurityConfiguration.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Security/SecurityConfiguration.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -37,5 +37,5 @@
             @Override
             public void addCorsMappings(CorsRegistry registry) {
-                registry.addMapping("/**").allowedOrigins("http://192.168.0.29:3000", "http://192.168.0.28:3000")
+                registry.addMapping("/**").allowedOrigins("http://192.168.1.254:3000", "http://192.168.0.28:3000")
                         .allowCredentials(true);
             }
Index: springapp/src/main/java/mk/profesori/springapp/Service/Exception/DisallowedOperationException.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Service/Exception/DisallowedOperationException.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
+++ springapp/src/main/java/mk/profesori/springapp/Service/Exception/DisallowedOperationException.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -0,0 +1,7 @@
+package mk.profesori.springapp.Service.Exception;
+
+public class DisallowedOperationException extends RuntimeException{
+    public DisallowedOperationException(String message) {
+        super(message);
+    }
+}
Index: springapp/src/main/java/mk/profesori/springapp/Service/Exception/IncompatiblePostId.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Service/Exception/IncompatiblePostId.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
+++ springapp/src/main/java/mk/profesori/springapp/Service/Exception/IncompatiblePostId.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -0,0 +1,7 @@
+package mk.profesori.springapp.Service.Exception;
+
+public class IncompatiblePostId extends RuntimeException{
+    public IncompatiblePostId(String message) {
+        super(message);
+    }
+}
